### Please read before contributing

1) Do not post questions in the issues tracker. If you have any questions about
Devise, search the [Wiki](https://github.com/plataformatec/devise/wiki) or use
the [Mailing List](https://groups.google.com/group/plataformatec-devise) or
[Stack Overflow](http://stackoverflow.com/questions/tagged/devise).

2) If you find a security bug, **DO NOT** submit an issue here. Please send an
e-mail to [opensource@plataformatec.com.br](mailto:opensource@plataformatec.com.br)
instead.

3) If possible, replicate your issue with our
[guides/bug_report_templates/integration_test.rb](test case example), and attach
it to your issue or Pull Request - this way we have an isolated way to replicate
your issue and investigate it further.

4) Otherwise, please provide a fresh new Rails application that replicates your
issue on a public GitHub repository, as some scenarios might not be possible to
replicate using the standalone test case example.

5) Do a small search on the issues tracker before submitting your issue to see
if it was already reported / fixed. Duplicated issues will be closed to avoid
too much noise/duplication in the issue tracker.

6) When reporting an issue, include Rails, Devise and Warden versions. If you
are getting exceptions, please include the full backtrace.

7) Please do not attempt to translate Devise built in views. The views are meant
to be a starting point and not a final version. For historical references,
please look into closed issues/Pull regarding i18n.

8) Notice that all of your interactions in the project are expected to follow
our [Code of Conduct](CODE_OF_CONDUCT.md)

That's it! The more information you give, the easier it becomes for us to track
it down and fix it. Ideally, you should provide an application that reproduces
the error or a test case to Devise's suite.

Thanks!
